/*
Copyright (c) 2020 Red Hat, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// IMPORTANT: This file has been generated automatically, refrain from modifying it manually as all
// your changes will be lost when the file is generated again.

package v1 // github.com/openshift-online/ocm-sdk-go/clustersmgmt/v1

// AWSSTSPolicy represents the values of the 'AWSSTS_policy' type.
//
// Representation of an sts policies for rosa cluster
type AWSSTSPolicy struct {
	bitmap_ uint32
	id      string
	details string
	type_   string
}

// Empty returns true if the object is empty, i.e. no attribute has a value.
func (o *AWSSTSPolicy) Empty() bool {
	return o == nil || o.bitmap_ == 0
}

// ID returns the value of the 'ID' attribute, or
// the zero value of the type if the attribute doesn't have a value.
//
// Policy ID
func (o *AWSSTSPolicy) ID() string {
	if o != nil && o.bitmap_&1 != 0 {
		return o.id
	}
	return ""
}

// GetID returns the value of the 'ID' attribute and
// a flag indicating if the attribute has a value.
//
// Policy ID
func (o *AWSSTSPolicy) GetID() (value string, ok bool) {
	ok = o != nil && o.bitmap_&1 != 0
	if ok {
		value = o.id
	}
	return
}

// Details returns the value of the 'details' attribute, or
// the zero value of the type if the attribute doesn't have a value.
//
// Policy Details
func (o *AWSSTSPolicy) Details() string {
	if o != nil && o.bitmap_&2 != 0 {
		return o.details
	}
	return ""
}

// GetDetails returns the value of the 'details' attribute and
// a flag indicating if the attribute has a value.
//
// Policy Details
func (o *AWSSTSPolicy) GetDetails() (value string, ok bool) {
	ok = o != nil && o.bitmap_&2 != 0
	if ok {
		value = o.details
	}
	return
}

// Type returns the value of the 'type' attribute, or
// the zero value of the type if the attribute doesn't have a value.
//
// Type of policy operator/account role
func (o *AWSSTSPolicy) Type() string {
	if o != nil && o.bitmap_&4 != 0 {
		return o.type_
	}
	return ""
}

// GetType returns the value of the 'type' attribute and
// a flag indicating if the attribute has a value.
//
// Type of policy operator/account role
func (o *AWSSTSPolicy) GetType() (value string, ok bool) {
	ok = o != nil && o.bitmap_&4 != 0
	if ok {
		value = o.type_
	}
	return
}

// AWSSTSPolicyListKind is the name of the type used to represent list of objects of
// type 'AWSSTS_policy'.
const AWSSTSPolicyListKind = "AWSSTSPolicyList"

// AWSSTSPolicyListLinkKind is the name of the type used to represent links to list
// of objects of type 'AWSSTS_policy'.
const AWSSTSPolicyListLinkKind = "AWSSTSPolicyListLink"

// AWSSTSPolicyNilKind is the name of the type used to nil lists of objects of
// type 'AWSSTS_policy'.
const AWSSTSPolicyListNilKind = "AWSSTSPolicyListNil"

// AWSSTSPolicyList is a list of values of the 'AWSSTS_policy' type.
type AWSSTSPolicyList struct {
	href  string
	link  bool
	items []*AWSSTSPolicy
}

// Len returns the length of the list.
func (l *AWSSTSPolicyList) Len() int {
	if l == nil {
		return 0
	}
	return len(l.items)
}

// Empty returns true if the list is empty.
func (l *AWSSTSPolicyList) Empty() bool {
	return l == nil || len(l.items) == 0
}

// Get returns the item of the list with the given index. If there is no item with
// that index it returns nil.
func (l *AWSSTSPolicyList) Get(i int) *AWSSTSPolicy {
	if l == nil || i < 0 || i >= len(l.items) {
		return nil
	}
	return l.items[i]
}

// Slice returns an slice containing the items of the list. The returned slice is a
// copy of the one used internally, so it can be modified without affecting the
// internal representation.
//
// If you don't need to modify the returned slice consider using the Each or Range
// functions, as they don't need to allocate a new slice.
func (l *AWSSTSPolicyList) Slice() []*AWSSTSPolicy {
	var slice []*AWSSTSPolicy
	if l == nil {
		slice = make([]*AWSSTSPolicy, 0)
	} else {
		slice = make([]*AWSSTSPolicy, len(l.items))
		copy(slice, l.items)
	}
	return slice
}

// Each runs the given function for each item of the list, in order. If the function
// returns false the iteration stops, otherwise it continues till all the elements
// of the list have been processed.
func (l *AWSSTSPolicyList) Each(f func(item *AWSSTSPolicy) bool) {
	if l == nil {
		return
	}
	for _, item := range l.items {
		if !f(item) {
			break
		}
	}
}

// Range runs the given function for each index and item of the list, in order. If
// the function returns false the iteration stops, otherwise it continues till all
// the elements of the list have been processed.
func (l *AWSSTSPolicyList) Range(f func(index int, item *AWSSTSPolicy) bool) {
	if l == nil {
		return
	}
	for index, item := range l.items {
		if !f(index, item) {
			break
		}
	}
}
