/*
Copyright (c) 2020 Red Hat, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// IMPORTANT: This file has been generated automatically, refrain from modifying it manually as all
// your changes will be lost when the file is generated again.

package v1 // github.com/openshift-online/ocm-sdk-go/clustersmgmt/v1

// ManagedServiceBuilder contains the data and logic needed to build 'managed_service' objects.
//
// Contains the necessary attributes to support role-based authentication on AWS.
type ManagedServiceBuilder struct {
	bitmap_ uint32
	enabled bool
}

// NewManagedService creates a new builder of 'managed_service' objects.
func NewManagedService() *ManagedServiceBuilder {
	return &ManagedServiceBuilder{}
}

// Empty returns true if the builder is empty, i.e. no attribute has a value.
func (b *ManagedServiceBuilder) Empty() bool {
	return b == nil || b.bitmap_ == 0
}

// Enabled sets the value of the 'enabled' attribute to the given value.
//
//
func (b *ManagedServiceBuilder) Enabled(value bool) *ManagedServiceBuilder {
	b.enabled = value
	b.bitmap_ |= 1
	return b
}

// Copy copies the attributes of the given object into this builder, discarding any previous values.
func (b *ManagedServiceBuilder) Copy(object *ManagedService) *ManagedServiceBuilder {
	if object == nil {
		return b
	}
	b.bitmap_ = object.bitmap_
	b.enabled = object.enabled
	return b
}

// Build creates a 'managed_service' object using the configuration stored in the builder.
func (b *ManagedServiceBuilder) Build() (object *ManagedService, err error) {
	object = new(ManagedService)
	object.bitmap_ = b.bitmap_
	object.enabled = b.enabled
	return
}
